<?php
  
  //$after = true;
  
  if ($after) {
    include_once('./tree_after.php');
  } else {
    include_once('./tree_before.php');
  }
  
  function getchildren($tree, $id) {
    $subtree = subtree($tree, $id);
    return isset($subtree['children']) ? $subtree['children'] : false;
  }
  
  function subtree($nodes, $id) {
    if (@is_array($nodes) && @count($nodes)) {
      foreach ($nodes as $node) {
        if ($node['id'] == $id) return $node;
        else {
          if (@is_array($node['children']) && @count($node['children'])) {
            $subnodes = subtree($node['children'], $id);
            if ($subnodes['id'] == $id) return $subnodes;
          }
        }
      }
    }
  }
  
  $root_id = 0;
  $id = isset($_GET['id']) ? intval($_GET['id']) : $root_id;
  
  $xml['xml'] = new DOMDocument('1.0', 'utf-8');
  $xml['tree'] = $xml['xml']->createElement('tree');
  $xml['tree']->setAttribute('id', $id);
  
  $children = getchildren($tree, $id);
  
  foreach ($children as $n => $child) {
    $xml['item'][$n] = $xml['xml']->createElement('item');
    $xml['item'][$n]->setAttribute('child', (@is_array($child['children']) && @count($child['children']) ? '1' : '0'));
    $xml['item'][$n]->setAttribute('id', $child['id']);
    $xml['item'][$n]->setAttribute('text', $child['title']);
    $xml['item'][$n]->setAttribute('tooltip', 'id: ' . intval($child['id']));
    $xml['userdata'][$n] = $xml['xml']->createElement('userdata', 'ud_data');
    $xml['userdata'][$n]->setAttribute('name', 'ud_block');
    $xml['item'][$n]->appendChild($xml['userdata'][$n]);
    $xml['tree']->appendChild($xml['item'][$n]);
  }
  
  $xml['xml']->appendChild($xml['tree']);
  $xml['xml']->formatOutput = true;
  $output = $xml['xml']->saveXML();
  
  header('Content-Type: text/xml');
  echo $output;
  exit;
  
?>